package parkomat.model;

import java.time.DayOfWeek;
import java.time.LocalTime;
import java.util.ArrayList;
import java.util.List;

import parkomat.model.PagamentoAttivo;

public class TariffaValida extends Tariffa {

	public TariffaValida(Tariffa t) {
		super(t.getNomeTariffa(), t.getCostoOrario(), t.getFranchigia(), t.getDurataSostaMinima(), t.getFasce());
		makeValid();
	}
	
	private void makeValid(){
		for (DayOfWeek day : DayOfWeek.values()) {
			if (!isValid(day)) makeValid(day);
		}
	} 
	
	private void makeValid(DayOfWeek day) {
		List<FasciaTariffaria> fasce = this.getFasce().get(day), 
								newFasce = new ArrayList<>();
		if (fasce==null) fasce= new ArrayList<>();
		if (fasce.isEmpty()) {
			// System.out.println("adding  " + day.toString() + " " + FasciaTariffaria.GIORNATA_GRATUITA);
			fasce.add(FasciaTariffaria.GIORNATA_GRATUITA);
		}
		LocalTime current = LocalTime.of(0,0); // si parte da mezzanotte...
		for(FasciaTariffaria f : fasce) {
			if (!current.equals(f.getOraDa())) {
				LocalTime oraDa    = current;
				LocalTime oraFinoA = f.getOraDa();//.minusMinutes(1);
				FasciaTariffaria nuovaFascia = 
						new FasciaTariffaria(oraDa, oraFinoA, PagamentoAttivo.GRATUITO);
				// System.out.println("adding  " + day.toString() + " " + nuovaFascia);
				current = f.getOraFinoA(); //.plusMinutes(1);
				newFasce.add(nuovaFascia);
			}
			newFasce.add(f);
			// System.out.println("copying " + day.toString() + " " + f);
			current = f.getOraFinoA();//.plusMinutes(1);
		}
		if(!current.equals(LocalTime.of(0,0))) {
			FasciaTariffaria nuovaFascia = new FasciaTariffaria(current, LocalTime.of(0,0), PagamentoAttivo.GRATUITO);
			// System.out.println("adding  " + day.toString() + " " + nuovaFascia);
			newFasce.add(nuovaFascia);
		}
		this.getFasce().put(day,newFasce);
	}
	
}
